# LiveCam

Kamera-Steaming-Setup auf Basis von ZOTAC ZBOX PRO PI335 pico.

## Vorbereitung (debian 10)

`apt install htop git vim lshw sudo screen tmux`

* /etc/vim/vimrc.local erstellen:

`autocmd BufEnter * set mouse=`

* /etc/apt/sources.list alle Zeilen erweitern auf:

`… main contrib non-free`

* /etc/default/grub in Zeile `GRUB_CMDLINE_LINUX_DEFAULT=` einfügen:

`rootflags=data=journal`

* grub updaten:

`update-grub2`

* Pakete nachinstallieren:
```
apt update
apt install firmware-linux firmware-iwlwifi firmware-realtek wpasupplicant wireless-tools iw gstreamer1.0-tools gstreamer1.0-plugins-base gstreamer1.0-plugins-good gstreamer1.0-plugins-bad gstreamer1.0-plugins-ugly gstreamer1.0-libav gstreamer1.0-alsa alsa-utils v4l-utils
```

* in /etc/network/interfaces
```
# Eventnetz
allow-hotplug wlo2
iface wlo2 inet manual
	wpa-ssid "Begehungen Inklusion"
	wpa-psk xxxxxxxxxx
	up iw wlo2 set power_save off
	post-up wpa_cli -i wlo2 set fast_reauth 1
	post-up wpa_cli -i wlo2 set ap_scan 1
	post-up wpa_cli -i wlo2 set autoscan=periodic:30
	post-up wpa_cli -i wlo2 set_network 0 bgscan "\"simple:5:-60:60\""

iface wlo2 inet dhcp

iface wlo2 inet6 static
	address fd63:bb49:f2eb:1337::c1/64
```

* /etc/hosts ergänzen:
```
fd63:bb49:f2eb:1337::c1         cam1
fd63:bb49:f2eb:1337::c2         cam2
fd63:bb49:f2eb:1337::a1         terminal1
fd63:bb49:f2eb:1337::a2         terminal2
```

```
useradd -m livecam -s /bin/bash -G video,audio,sudo
passwd livecam # set the usual password
su -l livecam

reboot && exit
```

* ggf. Anpassung der Audiodevices in den Scripten (`aplay -l` und `arecord -l` zur Ermittlung der Nummern)
